// DirCompare.cpp : Defines the entry point for the console application.
//

#pragma warning(disable:4786)

#include <sstream>
#include <fstream>
#include <string>
#include <set>

#include <crypto/files.h>
#include <crypto/sha.h>
using namespace CryptoPP;

#include <boost/lexical_cast.hpp>

#include <windows.h>
#include <tchar.h>

void traverse(const std::wstring &prefix, const std::wstring &path, std::wofstream &outfile)
{
	std::wstring curpath;
	std::set<std::wstring> pathstodo;
	std::set<std::wstring> filesincurpath;
	
	pathstodo.insert(path);

	HANDLE fhandle;
	WIN32_FIND_DATA fd;

	do {
		curpath=*pathstodo.begin();
		pathstodo.erase(pathstodo.begin());
		fhandle=FindFirstFileEx((prefix+curpath+std::wstring(_T("*"))).c_str(), FindExInfoStandard, &fd, FindExSearchNameMatch, NULL, 0);
		if ( fhandle != INVALID_HANDLE_VALUE ) {
			do {
				if ( fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY ) {
					if ( std::wstring(fd.cFileName) != _T(".") && std::wstring(fd.cFileName) != _T("..") ) {
						pathstodo.insert(curpath + std::wstring(fd.cFileName) + std::wstring(_T("\\")));
					}
				} else {

					std::wstring hash_val;

					char temp1[256];
					char * temp=( ((prefix + curpath + std::wstring(fd.cFileName)).size() > 255) ? new char[(prefix + curpath + std::wstring(fd.cFileName)).size()] : temp1 );
					if ( temp != NULL ) {
						try {
							wcstombs(temp, (prefix + curpath + std::wstring(fd.cFileName)).c_str(), 255);

							SHA hash;
							byte abDigest[SHA::DIGESTSIZE];
							{
								std::ifstream tempfile;
								tempfile.open(temp, std::ios::in | std::ios::binary);
								FileSource(tempfile, true, new HashFilter(hash, new ArraySink(abDigest, sizeof abDigest)));
							}

							if ( temp != temp1 ) delete temp;

							std::wstringstream tstr;
							tstr >> std::hex;
							for(byte * it=abDigest; it!=abDigest+SHA::DIGESTSIZE; ++it) {
								tstr << *it;
							}
							tstr >> hash_val;
						} catch(...) {
							hash_val = _T("#Error#");
						}
					} else {
						hash_val = _T("#Error#");
					}

					filesincurpath.insert(curpath + std::wstring(fd.cFileName) + std::wstring(_T(" : ")) + boost::lexical_cast<std::wstring>(fd.nFileSizeLow) + std::wstring(_T(" : ")) + hash_val);
				}
			} while(FindNextFile(fhandle, &fd));
			FindClose(fhandle);
			{
				for(std::set<std::wstring>::const_iterator it=filesincurpath.begin(); it!=filesincurpath.end(); ++it) {
					outfile << *it << std::endl;
				}
			}
			filesincurpath.clear();
		}
	} while(!pathstodo.empty());
}

int wmain(int argc, wchar_t *argv[ ])
{
	if ( argc != 3 ) {
		std::wcout << "Need two parameters!" << std::endl ;
		return 1;
	}

	std::wstring srcpath(argv[2]);
	char * destfilename=new char[(wcslen(argv[1])*2)+2];
	wcstombs(destfilename, argv[1], (wcslen(argv[1])*2)+1);

	{
		std::wofstream outfile(destfilename);
		traverse(srcpath, _T("\\"),outfile);
	}

	return 0;
}
